//-----------------------------------------------------------------------------
// 
// 		cwCu		GraphFilternvO
// 
//  	Ver 3.12e
// 
//-----------------------------------------------------------------------------

// cwCu쐬p`
#define __DX_MAKE

// CN[h ---------------------------------------------------------------
#include "DxGraphicsFilter.h"
#include "DxGraphics.h"
#include "DxBaseFunc.h"
#include "Windows/DxGraphicsFilterWin.h"

#ifndef DX_NON_FILTER

#ifdef DX_USE_NAMESPACE

namespace DxLib
{

#endif // DX_USE_NAMESPACE

// }N` -----------------------------------------------------------------

// \̐錾 -----------------------------------------------------------------

// f[^` -----------------------------------------------------------------


GRAPHFILTER_SHADER_HANDLE GraphFilterShaderHandle ;

// ֐錾 -------------------------------------------------------------------

static int	GraphFilter_GetSoftImage( int GrHandle, BASEIMAGE *BaseImage, RECT *GetRect = NULL ) ;
static int	GraphFilter_SoftImageSetup( GRAPHFILTER_INFO *Info, int DestDiscard = TRUE, int DestWidth = -1, int DestHeight = -1 ) ;
static int	GraphFilter_SoftImageTerminate( GRAPHFILTER_INFO *Info ) ;

// vO -----------------------------------------------------------------

// tB^[̃VF[_[nh
extern int GraphFilter_Initialize( void )
{
	// VF[_[nhlZbg
	_MEMSET( &GraphFilterShaderHandle, 0xff, sizeof( GraphFilterShaderHandle ) ) ;

	// I
	return 0 ;
}

// 摜ɃtB^[s
extern int NS_GraphFilter( int GrHandle, int FilterType /* DX_GRAPH_FILTER_GAUSS_H  */ , ... )
{
	int Result ;
	va_list VaList ;
	int W, H ;

	va_start( VaList, FilterType ) ;

	NS_GetGraphSize( GrHandle, &W, &H ) ;

	Result = GraphFilter_RectBltBase_PF( FALSE, GrHandle, -1, GrHandle, 0, FilterType, 0, 0, W, H, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// 摜̃tB^[t]s
extern int NS_GraphFilterBlt( int SrcGrHandle, int DestGrHandle, int FilterType, ... )
{
	int Result ;
	va_list VaList ;
	int SrcW, SrcH ;

	va_start( VaList, FilterType ) ;

	NS_GetGraphSize( SrcGrHandle, &SrcW, &SrcH ) ;

	Result = GraphFilter_RectBltBase_PF( FALSE, SrcGrHandle, -1, DestGrHandle, 0, FilterType, 0, 0, SrcW, SrcH, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// 摜̃tB^[t]s( `w )
extern int NS_GraphFilterRectBlt( int SrcGrHandle, int DestGrHandle, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int DestX, int DestY, int FilterType, ... )
{
	int Result ;
	va_list VaList ;

	va_start( VaList, FilterType ) ;

	Result = GraphFilter_RectBltBase_PF( FALSE, SrcGrHandle, -1, DestGrHandle, 0, FilterType, SrcX1, SrcY1, SrcX2, SrcY2, 0, 0, FALSE, DestX, DestY, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// ̉摜uh
extern	int	NS_GraphBlend( int GrHandle, int BlendGrHandle, int BlendRatio, int BlendType, ... )
{
	int Result ;
	va_list VaList ;
	int W, H ;

	va_start( VaList, BlendType ) ;

	NS_GetGraphSize( GrHandle, &W, &H ) ;

	Result = GraphFilter_RectBltBase_PF( TRUE, GrHandle, BlendGrHandle, GrHandle, BlendRatio, BlendType, 0, 0, W, H, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// ̉摜uhČʂw̉摜ɏo͂
extern	int	NS_GraphBlendBlt( int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int BlendRatio, int BlendType, ... )
{
	int Result ;
	va_list VaList ;
	int SrcW, SrcH ;

	va_start( VaList, BlendType ) ;

	NS_GetGraphSize( SrcGrHandle, &SrcW, &SrcH ) ;

	Result = GraphFilter_RectBltBase_PF( TRUE, SrcGrHandle, BlendGrHandle, DestGrHandle, BlendRatio, BlendType, 0, 0, SrcW, SrcH, 0, 0, FALSE, 0, 0, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}

// ̉摜uhČʂw̉摜ɏo͂( `w )
extern	int	NS_GraphBlendRectBlt( int SrcGrHandle, int BlendGrHandle, int DestGrHandle, int SrcX1, int SrcY1, int SrcX2, int SrcY2, int BlendX, int BlendY, int DestX, int DestY, int BlendRatio, int BlendType, ... )
{
	int Result ;
	va_list VaList ;

	va_start( VaList, BlendType ) ;

	Result = GraphFilter_RectBltBase_PF( TRUE, SrcGrHandle, BlendGrHandle, DestGrHandle, BlendRatio, BlendType, SrcX1, SrcY1, SrcX2, SrcY2, BlendX, BlendY, TRUE, DestX, DestY, VaList ) ;

	va_end( VaList ) ;

	return Result ;
}


static int GraphFilter_GetSoftImage( int GrHandle, BASEIMAGE *BaseImage, RECT *GetRect )
{
	RECT TempRect ;
	int Width, Height ;
	BASEIMAGE SurfaceImage ;
	IMAGEDATA *Image ;
	IMAGEDATA_HARD_DRAW *HardDraw ;
	RECT SrcRect ;
	RECT DestRect ;
	int i ;
	int temp ;

	if( GRAPHCHK( GrHandle, Image ) )
		return -1 ;

	if( GetRect == NULL )
	{
		NS_GetGraphSize( GrHandle, &Width, &Height ) ;

		TempRect.left = 0 ;
		TempRect.right = Width ;
		TempRect.top = 0 ;
		TempRect.bottom = Height ;

		GetRect = &TempRect ;
	}
	else
	{
		Width = GetRect->right - GetRect->left ;
		Height = GetRect->bottom - GetRect->top ;
	}

	if( NS_CreateARGB8ColorBaseImage( Width, Height, BaseImage ) < 0 )
		return -1 ;

	if( Image->Orig->FormatDesc.TextureFlag )
	{
		HardDraw = Image->Hard.Draw ;
		for( i = 0 ; i < Image->Hard.DrawNum ; i ++, HardDraw ++ )
		{
			SrcRect.left   = HardDraw->UsePosX ;
			SrcRect.right  = HardDraw->UsePosX + HardDraw->Width ;
			SrcRect.top    = HardDraw->UsePosY ;
			SrcRect.bottom = HardDraw->UsePosY + HardDraw->Height ;

			DestRect.left   = HardDraw->DrawPosX ;
			DestRect.right  = HardDraw->DrawPosX + HardDraw->Width ;
			DestRect.top    = HardDraw->DrawPosY ;
			DestRect.bottom = HardDraw->DrawPosY + HardDraw->Height ;

			if( DestRect.left   >= GetRect->right ||
				DestRect.right  <= GetRect->left ||
				DestRect.top    >= GetRect->bottom ||
				DestRect.bottom <= GetRect->top )
				continue ;

			if( DestRect.left < GetRect->left )
			{
				temp = GetRect->left - DestRect.left ;
				SrcRect.left += temp ;
				DestRect.left += temp ;
			}
			if( DestRect.right > GetRect->right )
			{
				temp = DestRect.right - GetRect->right ;
				SrcRect.right -= temp ;
				DestRect.right -= temp ;
			}
			if( DestRect.top < GetRect->top )
			{
				temp = GetRect->top - DestRect.top ;
				SrcRect.top += temp ;
				DestRect.top += temp ;
			}
			if( DestRect.bottom > GetRect->bottom )
			{
				temp = DestRect.bottom - GetRect->bottom ;
				SrcRect.bottom -= temp ;
				DestRect.bottom -= temp ;
			}

			if( Graphics_Screen_LockDrawScreen( &SrcRect, &SurfaceImage, GrHandle, 0, TRUE, i ) < 0 )
			{
				NS_ReleaseBaseImage( BaseImage ) ;
				return -1 ;
			}

			NS_BltBaseImage( 0, 0, SrcRect.right - SrcRect.left, SrcRect.bottom - SrcRect.top, DestRect.left, DestRect.top, &SurfaceImage, BaseImage ) ;
			Graphics_Screen_UnlockDrawScreen() ;
		}
	}
	else
	{
		if( Graphics_Screen_LockDrawScreen( GetRect, &SurfaceImage, GrHandle, 0, TRUE, 0 ) < 0 )
		{
			NS_ReleaseBaseImage( BaseImage ) ;
			return -1 ;
		}

		NS_BltBaseImage( 0, 0, Width, Height, 0, 0, &SurfaceImage, BaseImage ) ;
		Graphics_Screen_UnlockDrawScreen() ;
	}


	// I
	return 0 ;
}

static int	GraphFilter_SoftImageSetup( GRAPHFILTER_INFO *Info, int DestDiscard, int DestWidth, int DestHeight )
{
	RECT Rect ;
	int SrcWidth ;
	int SrcHeight ;

	SrcWidth = Info->SrcX2 - Info->SrcX1 ;
	SrcHeight = Info->SrcY2 - Info->SrcY1 ;

	if( DestWidth < 0 || DestHeight < 0 )
	{
		DestWidth = SrcWidth ;
		DestHeight = SrcHeight ;
	}
	Info->DestWidth = DestWidth ;
	Info->DestHeight = DestHeight ;

	Info->SrcImage.GraphData = NULL ;
	Info->BlendImage.GraphData = NULL ;
	Info->DestImage.GraphData = NULL ;

	Rect.left   = Info->SrcX1 ;
	Rect.right  = Info->SrcX2 ;
	Rect.top    = Info->SrcY1 ;
	Rect.bottom = Info->SrcY2 ;

	if( GraphFilter_GetSoftImage( Info->SrcGrHandle, &Info->SrcImage, &Rect ) < 0 )
		goto ERR ;

	if( Info->IsBlend )
	{
		if( GraphFilter_GetSoftImage( Info->BlendGrHandle, &Info->BlendImage, &Rect ) < 0 )
			goto ERR ;
	}

	if( DestDiscard )
	{
		if( NS_CreateARGB8ColorBaseImage( Info->DestWidth, Info->DestHeight, &Info->DestImage ) < 0 )
			goto ERR ;
	}
	else
	{
		Rect.left   = Info->DestX ;
		Rect.right  = Info->DestX + Info->DestWidth ;
		Rect.top    = Info->DestY ;
		Rect.bottom = Info->DestY + Info->DestHeight ;
		if( GraphFilter_GetSoftImage( Info->DestGrHandle, &Info->DestImage, &Rect ) < 0 )
			goto ERR ;
	}

	// I
	return 0 ;

ERR :
	if( Info->SrcImage.GraphData )
		NS_ReleaseBaseImage( &Info->SrcImage ) ;

	if( Info->BlendImage.GraphData )
		NS_ReleaseBaseImage( &Info->BlendImage ) ;

	if( Info->DestImage.GraphData )
		NS_ReleaseBaseImage( &Info->DestImage ) ;

	return -1 ;
}

static int	GraphFilter_SoftImageTerminate( GRAPHFILTER_INFO *Info )
{
	if( Info->SrcImage.GraphData )
		NS_ReleaseBaseImage( &Info->SrcImage ) ;

	if( Info->BlendImage.GraphData )
		NS_ReleaseBaseImage( &Info->BlendImage ) ;

	if( Info->DestImage.GraphData )
	{
		RECT Rect ;

		Rect.left   = 0 ;
		Rect.top    = 0 ;
		Rect.right  = Info->DestWidth ;
		Rect.bottom = Info->DestHeight ;
		Graphics_Image_BltBmpOrBaseImageToGraph3(
			&Rect,
			Info->DestX, Info->DestY,
			Info->DestGrHandle,
			&Info->DestImage,
			NULL,
			FALSE,
			FALSE,
			FALSE
		) ;
/*
		if( Info->UseTempDestImage )
		{
			if( Info->TempDestImage.GraphData )
			{
				NS_BltBaseImage( 0, 0, Info->DestWidth, Info->DestHeight, 0, 0, &Info->TempDestImage, &Info->DestImage ) ;
			}
		}

		Graphics_Screen_UnlockDrawScreen() ;
*/
	}

	if( Info->DestImage.GraphData )
		NS_ReleaseBaseImage( &Info->DestImage ) ;

	return 0 ;
}

extern int GraphFilter_Mono( GRAPHFILTER_INFO *Info, float Cb, float Cr )
{
	// l␳
	Cb /= 200.0f ;
	if( Cb < -0.5f )
	{
		Cb = -0.5f ;
	}
	else
	if( Cb > 0.5f )
	{
		Cb = 0.5f ;
	}

	Cr /= 200.0f ;
	if( Cr < -0.5f )
	{
		Cr = -0.5f ;
	}
	else
	if( Cr > 0.5f )
	{
		Cr = 0.5f ;
	}

	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_Mono_PF( Info, Cb, Cr ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int Y ;
		int RAdd ;
		int GAdd ;
		int BAdd ;
		int R, G, B ;

		RAdd = _FTOL( ( 1.40200f * Cr                 ) * 255.0f * 4096.0f ) ;
		GAdd = _FTOL( ( 0.34414f * Cb - 0.71414f * Cr ) * 255.0f * 4096.0f ) ;
		BAdd = _FTOL( ( 1.77200f * Cb                 ) * 255.0f * 4096.0f ) ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				Y = Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
					Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
					Src[ 2 ] * ( int )( 0.299f * 4096.0f ) ;
				B = ( Y + BAdd ) >> 12 ;
				G = ( Y + GAdd ) >> 12 ;
				R = ( Y + RAdd ) >> 12 ;
				if( B < 0 ) B = 0 ; else if( B > 255 ) B = 255 ;
				if( G < 0 ) G = 0 ; else if( G > 255 ) G = 255 ;
				if( R < 0 ) R = 0 ; else if( R > 255 ) R = 255 ;

				Dest[ 0 ] = ( BYTE )B ;
				Dest[ 1 ] = ( BYTE )G ;
				Dest[ 2 ] = ( BYTE )R ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int GraphFilter_Gauss( GRAPHFILTER_INFO *Info, int PixelWidth, float Param )
{
	static int   PrevPixelWidth ;
	static float PrevParam ;
	static float Table[ 16 ] ;
	int WeightNum ;

	// PixelWidth ̕␳
	if( PixelWidth <= 8 )
	{
		PixelWidth = 8 ;
	}
	else
	if( PixelWidth <= 16 )
	{
		PixelWidth = 16 ;
	}
	else
	{
		PixelWidth = 32 ;
	}
	WeightNum = PixelWidth / 2 ;

	if( Param >= 0.0000001f )
	{
		float Temp ;

		Temp = PrevParam - Param ;
		if( Temp > 0.0002f || Temp < -0.0002f || PrevPixelWidth != PixelWidth )
		{
			float Total ;
			int i ;

			PrevParam = Param ;
			PrevPixelWidth = PixelWidth ;

			Total = 0.0f ;
			for( i = 0 ; i < WeightNum ; i ++ )
			{
				Table[ i ] = _EXPF( -0.5f * ( float )( i * i ) / Param ) ;
				if( i == 0 )
				{
					Total += Table[ i ] ;
				}
				else
				{
					Total += 2.0f * Table[ i ] ;
				}
			}

			for( i = 0 ; i < WeightNum ; i ++ )
				Table[ i ] /= Total ;
		}
	}

	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_Gauss_PF( Info, PixelWidth, Param, Table ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		BYTE *MinSrc ;
		BYTE *MaxSrc ;
		BYTE *MinSrcStart ;
		BYTE *MaxSrcStart ;
		DWORD i, j ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcPitch ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int iTable[ 16 ] ;
		BYTE RGBA[ 64 ][ 4 ] ;
		BASEIMAGE WorkImage ;

		for( i = 0 ; i < ( DWORD )WeightNum ; i ++ )
		{
			iTable[ i ] = _FTOL( Table[ i ] * 65536.0f ) ;
		}

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
		{
			return -1 ;
		}

		if( Param < 0.0000001f )
		{
			Src = ( BYTE * )Info->SrcImage.GraphData ;
			Dest = ( BYTE * )Info->DestImage.GraphData ;

			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
			DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

			do
			{
				i = Width ;
				do
				{
					*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;

					Src  += 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
		}
		else
		{
			if( NS_CreateARGB8ColorBaseImage( Width, Height, &WorkImage ) >= 0 )
			{
				Src = ( BYTE * )Info->SrcImage.GraphData ;
				Dest = ( BYTE * )WorkImage.GraphData ;

				SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
				DestAddPitch = WorkImage.Pitch       - Width * 4 ;

				switch( PixelWidth )
				{
				case 8 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = Src ;
						MaxSrc = Src + 4 * ( Width - 1 ) ;
						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = i < 1          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 1 ) ;
							*( ( DWORD * )RGBA[  2 ] ) = i < 2          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 2 ) ;
							*( ( DWORD * )RGBA[  3 ] ) = i + 1 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 1 ) ;
							*( ( DWORD * )RGBA[  4 ] ) = i + 2 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 2 ) ;
							*( ( DWORD * )RGBA[  5 ] ) = i < 3          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 3 ) ;
							*( ( DWORD * )RGBA[  6 ] ) = i < 4          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 4 ) ;
							*( ( DWORD * )RGBA[  7 ] ) = i + 3 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 3 ) ;
							*( ( DWORD * )RGBA[  8 ] ) = i + 4 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 4 ) ;
							*( ( DWORD * )RGBA[  9 ] ) = i < 5          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 5 ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = i < 6          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 6 ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = i + 5 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 5 ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = i + 6 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 6 ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 16 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = Src ;
						MaxSrc = Src + 4 * ( Width - 1 ) ;
						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = i <  1          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  1 ) ;
							*( ( DWORD * )RGBA[  2 ] ) = i <  2          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  2 ) ;
							*( ( DWORD * )RGBA[  3 ] ) = i +  1 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  1 ) ;
							*( ( DWORD * )RGBA[  4 ] ) = i +  2 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  2 ) ;
							*( ( DWORD * )RGBA[  5 ] ) = i <  3          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  3 ) ;
							*( ( DWORD * )RGBA[  6 ] ) = i <  4          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  4 ) ;
							*( ( DWORD * )RGBA[  7 ] ) = i +  3 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  3 ) ;
							*( ( DWORD * )RGBA[  8 ] ) = i +  4 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  4 ) ;
							*( ( DWORD * )RGBA[  9 ] ) = i <  5          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  5 ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = i <  6          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  6 ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = i +  5 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  5 ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = i +  6 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  6 ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = i <  7          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  7 ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = i <  8          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  8 ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = i +  7 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  7 ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = i +  8 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  8 ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = i <  9          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  9 ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = i < 10          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 10 ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = i +  9 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  9 ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = i + 10 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 10 ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = i < 11          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 11 ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = i < 12          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 12 ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = i + 11 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 11 ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = i + 12 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 12 ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = i < 13          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 13 ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = i < 14          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 14 ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = i + 13 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 13 ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = i + 14 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 14 ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 32 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = Src ;
						MaxSrc = Src + 4 * ( Width - 1 ) ;
						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = i <  1          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  1 ) ;
							*( ( DWORD * )RGBA[  2 ] ) = i <  2          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  2 ) ;
							*( ( DWORD * )RGBA[  3 ] ) = i +  1 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  1 ) ;
							*( ( DWORD * )RGBA[  4 ] ) = i +  2 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  2 ) ;
							*( ( DWORD * )RGBA[  5 ] ) = i <  3          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  3 ) ;
							*( ( DWORD * )RGBA[  6 ] ) = i <  4          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  4 ) ;
							*( ( DWORD * )RGBA[  7 ] ) = i +  3 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  3 ) ;
							*( ( DWORD * )RGBA[  8 ] ) = i +  4 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  4 ) ;
							*( ( DWORD * )RGBA[  9 ] ) = i <  5          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  5 ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = i <  6          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  6 ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = i +  5 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  5 ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = i +  6 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  6 ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = i <  7          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  7 ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = i <  8          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  8 ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = i +  7 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  7 ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = i +  8 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  8 ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = i <  9          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src -  9 ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = i < 10          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 10 ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = i +  9 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src +  9 ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = i + 10 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 10 ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = i < 11          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 11 ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = i < 12          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 12 ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = i + 11 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 11 ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = i + 12 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 12 ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = i < 13          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 13 ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = i < 14          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 14 ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = i + 13 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 13 ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = i + 14 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 14 ) ;
							*( ( DWORD * )RGBA[ 29 ] ) = i < 15          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 15 ) ;
							*( ( DWORD * )RGBA[ 30 ] ) = i < 16          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 16 ) ;
							*( ( DWORD * )RGBA[ 31 ] ) = i + 15 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 15 ) ;
							*( ( DWORD * )RGBA[ 32 ] ) = i + 16 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 16 ) ;
							*( ( DWORD * )RGBA[ 33 ] ) = i < 17          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 17 ) ;
							*( ( DWORD * )RGBA[ 34 ] ) = i < 18          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 18 ) ;
							*( ( DWORD * )RGBA[ 35 ] ) = i + 17 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 17 ) ;
							*( ( DWORD * )RGBA[ 36 ] ) = i + 18 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 18 ) ;
							*( ( DWORD * )RGBA[ 37 ] ) = i < 19          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 19 ) ;
							*( ( DWORD * )RGBA[ 38 ] ) = i < 20          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 20 ) ;
							*( ( DWORD * )RGBA[ 39 ] ) = i + 19 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 19 ) ;
							*( ( DWORD * )RGBA[ 40 ] ) = i + 20 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 20 ) ;
							*( ( DWORD * )RGBA[ 41 ] ) = i < 21          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 21 ) ;
							*( ( DWORD * )RGBA[ 42 ] ) = i < 22          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 22 ) ;
							*( ( DWORD * )RGBA[ 43 ] ) = i + 21 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 21 ) ;
							*( ( DWORD * )RGBA[ 44 ] ) = i + 22 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 22 ) ;
							*( ( DWORD * )RGBA[ 45 ] ) = i < 23          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 23 ) ;
							*( ( DWORD * )RGBA[ 46 ] ) = i < 24          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 24 ) ;
							*( ( DWORD * )RGBA[ 47 ] ) = i + 23 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 23 ) ;
							*( ( DWORD * )RGBA[ 48 ] ) = i + 24 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 24 ) ;
							*( ( DWORD * )RGBA[ 49 ] ) = i < 25          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 25 ) ;
							*( ( DWORD * )RGBA[ 50 ] ) = i < 26          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 26 ) ;
							*( ( DWORD * )RGBA[ 51 ] ) = i + 25 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 25 ) ;
							*( ( DWORD * )RGBA[ 52 ] ) = i + 26 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 26 ) ;
							*( ( DWORD * )RGBA[ 53 ] ) = i < 27          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 27 ) ;
							*( ( DWORD * )RGBA[ 54 ] ) = i < 28          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 28 ) ;
							*( ( DWORD * )RGBA[ 55 ] ) = i + 27 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 27 ) ;
							*( ( DWORD * )RGBA[ 56 ] ) = i + 28 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 28 ) ;
							*( ( DWORD * )RGBA[ 57 ] ) = i < 29          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 29 ) ;
							*( ( DWORD * )RGBA[ 58 ] ) = i < 30          ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )Src - 30 ) ;
							*( ( DWORD * )RGBA[ 59 ] ) = i + 29 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 29 ) ;
							*( ( DWORD * )RGBA[ 60 ] ) = i + 30 >= Width ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )Src + 30 ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 0 ] + RGBA[ 30 ][ 0 ] + RGBA[ 31 ][ 0 ] + RGBA[ 32 ][ 0 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 0 ] + RGBA[ 34 ][ 0 ] + RGBA[ 35 ][ 0 ] + RGBA[ 36 ][ 0 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 0 ] + RGBA[ 38 ][ 0 ] + RGBA[ 39 ][ 0 ] + RGBA[ 40 ][ 0 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 0 ] + RGBA[ 42 ][ 0 ] + RGBA[ 43 ][ 0 ] + RGBA[ 44 ][ 0 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 0 ] + RGBA[ 46 ][ 0 ] + RGBA[ 47 ][ 0 ] + RGBA[ 48 ][ 0 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 0 ] + RGBA[ 50 ][ 0 ] + RGBA[ 51 ][ 0 ] + RGBA[ 52 ][ 0 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 0 ] + RGBA[ 54 ][ 0 ] + RGBA[ 55 ][ 0 ] + RGBA[ 56 ][ 0 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 0 ] + RGBA[ 58 ][ 0 ] + RGBA[ 59 ][ 0 ] + RGBA[ 60 ][ 0 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 1 ] + RGBA[ 30 ][ 1 ] + RGBA[ 31 ][ 1 ] + RGBA[ 32 ][ 1 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 1 ] + RGBA[ 34 ][ 1 ] + RGBA[ 35 ][ 1 ] + RGBA[ 36 ][ 1 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 1 ] + RGBA[ 38 ][ 1 ] + RGBA[ 39 ][ 1 ] + RGBA[ 40 ][ 1 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 1 ] + RGBA[ 42 ][ 1 ] + RGBA[ 43 ][ 1 ] + RGBA[ 44 ][ 1 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 1 ] + RGBA[ 46 ][ 1 ] + RGBA[ 47 ][ 1 ] + RGBA[ 48 ][ 1 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 1 ] + RGBA[ 50 ][ 1 ] + RGBA[ 51 ][ 1 ] + RGBA[ 52 ][ 1 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 1 ] + RGBA[ 54 ][ 1 ] + RGBA[ 55 ][ 1 ] + RGBA[ 56 ][ 1 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 1 ] + RGBA[ 58 ][ 1 ] + RGBA[ 59 ][ 1 ] + RGBA[ 60 ][ 1 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 2 ] + RGBA[ 30 ][ 2 ] + RGBA[ 31 ][ 2 ] + RGBA[ 32 ][ 2 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 2 ] + RGBA[ 34 ][ 2 ] + RGBA[ 35 ][ 2 ] + RGBA[ 36 ][ 2 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 2 ] + RGBA[ 38 ][ 2 ] + RGBA[ 39 ][ 2 ] + RGBA[ 40 ][ 2 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 2 ] + RGBA[ 42 ][ 2 ] + RGBA[ 43 ][ 2 ] + RGBA[ 44 ][ 2 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 2 ] + RGBA[ 46 ][ 2 ] + RGBA[ 47 ][ 2 ] + RGBA[ 48 ][ 2 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 2 ] + RGBA[ 50 ][ 2 ] + RGBA[ 51 ][ 2 ] + RGBA[ 52 ][ 2 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 2 ] + RGBA[ 54 ][ 2 ] + RGBA[ 55 ][ 2 ] + RGBA[ 56 ][ 2 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 2 ] + RGBA[ 58 ][ 2 ] + RGBA[ 59 ][ 2 ] + RGBA[ 60 ][ 2 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 3 ] + RGBA[ 30 ][ 3 ] + RGBA[ 31 ][ 3 ] + RGBA[ 32 ][ 3 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 3 ] + RGBA[ 34 ][ 3 ] + RGBA[ 35 ][ 3 ] + RGBA[ 36 ][ 3 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 3 ] + RGBA[ 38 ][ 3 ] + RGBA[ 39 ][ 3 ] + RGBA[ 40 ][ 3 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 3 ] + RGBA[ 42 ][ 3 ] + RGBA[ 43 ][ 3 ] + RGBA[ 44 ][ 3 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 3 ] + RGBA[ 46 ][ 3 ] + RGBA[ 47 ][ 3 ] + RGBA[ 48 ][ 3 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 3 ] + RGBA[ 50 ][ 3 ] + RGBA[ 51 ][ 3 ] + RGBA[ 52 ][ 3 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 3 ] + RGBA[ 54 ][ 3 ] + RGBA[ 55 ][ 3 ] + RGBA[ 56 ][ 3 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 3 ] + RGBA[ 58 ][ 3 ] + RGBA[ 59 ][ 3 ] + RGBA[ 60 ][ 3 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;
				}

				Src = ( BYTE * )WorkImage.GraphData ;
				Dest = ( BYTE * )Info->DestImage.GraphData ;
				MinSrcStart = Src ;
				MaxSrcStart = Src + WorkImage.Pitch * ( Height - 1 ) ;

				SrcPitch     = WorkImage.Pitch ;
				SrcAddPitch  = WorkImage.Pitch       - Width * 4 ;
				DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

				switch( PixelWidth )
				{
				case 8 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = MinSrcStart ;
						MaxSrc = MaxSrcStart ;

						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = j < 1           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 1 ) ) ;
							*( ( DWORD * )RGBA[  2 ] ) = j < 2           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 2 ) ) ;
							*( ( DWORD * )RGBA[  3 ] ) = j + 1 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 1 ) ) ;
							*( ( DWORD * )RGBA[  4 ] ) = j + 2 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 2 ) ) ;
							*( ( DWORD * )RGBA[  5 ] ) = j < 3           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 3 ) ) ;
							*( ( DWORD * )RGBA[  6 ] ) = j < 4           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 4 ) ) ;
							*( ( DWORD * )RGBA[  7 ] ) = j + 3 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 3 ) ) ;
							*( ( DWORD * )RGBA[  8 ] ) = j + 4 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 4 ) ) ;
							*( ( DWORD * )RGBA[  9 ] ) = j < 5           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 5 ) ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = j < 6           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 6 ) ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = j + 5 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 5 ) ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = j + 6 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 6 ) ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] ) >> 1 ) ) >> 16 ) ;

							MinSrc += 4 ;
							MaxSrc += 4 ;
							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 16 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = MinSrcStart ;
						MaxSrc = MaxSrcStart ;

						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = j <  1           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  2 ] ) = j <  2           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  3 ] ) = j +  1 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  4 ] ) = j +  2 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  5 ] ) = j <  3           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  6 ] ) = j <  4           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  7 ] ) = j +  3 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  8 ] ) = j +  4 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  9 ] ) = j <  5           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = j <  6           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = j +  5 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = j +  6 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = j <  7           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = j <  8           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = j +  7 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = j +  8 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = j <  9           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = j < 10           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = j +  9 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = j + 10 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = j < 11           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = j < 12           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = j + 11 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = j + 12 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = j < 13           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = j < 14           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 14 ) ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = j + 13 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = j + 14 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 14 ) ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[ 1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[ 2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[ 3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[ 4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[ 5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[ 6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[ 7 ] ) >> 1 ) ) >> 16 ) ;

							MinSrc += 4 ;
							MaxSrc += 4 ;
							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;

				case 32 :
					for( j = 0 ; j < Height ; j ++ )
					{
						MinSrc = MinSrcStart ;
						MaxSrc = MaxSrcStart ;

						for( i = 0 ; i < Width ; i ++ )
						{
							*( ( DWORD * )RGBA[  0 ] ) = *( ( DWORD * )Src ) ;
							*( ( DWORD * )RGBA[  1 ] ) = j <  1           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  2 ] ) = j <  2           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  3 ] ) = j +  1 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  1 ) ) ;
							*( ( DWORD * )RGBA[  4 ] ) = j +  2 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  2 ) ) ;
							*( ( DWORD * )RGBA[  5 ] ) = j <  3           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  6 ] ) = j <  4           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  7 ] ) = j +  3 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  3 ) ) ;
							*( ( DWORD * )RGBA[  8 ] ) = j +  4 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  4 ) ) ;
							*( ( DWORD * )RGBA[  9 ] ) = j <  5           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 10 ] ) = j <  6           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 11 ] ) = j +  5 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  5 ) ) ;
							*( ( DWORD * )RGBA[ 12 ] ) = j +  6 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  6 ) ) ;
							*( ( DWORD * )RGBA[ 13 ] ) = j <  7           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 14 ] ) = j <  8           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 15 ] ) = j +  7 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  7 ) ) ;
							*( ( DWORD * )RGBA[ 16 ] ) = j +  8 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  8 ) ) ;
							*( ( DWORD * )RGBA[ 17 ] ) = j <  9           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 18 ] ) = j < 10           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 19 ] ) = j +  9 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch *  9 ) ) ;
							*( ( DWORD * )RGBA[ 20 ] ) = j + 10 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 10 ) ) ;
							*( ( DWORD * )RGBA[ 21 ] ) = j < 11           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 22 ] ) = j < 12           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 23 ] ) = j + 11 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 11 ) ) ;
							*( ( DWORD * )RGBA[ 24 ] ) = j + 12 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 12 ) ) ;
							*( ( DWORD * )RGBA[ 25 ] ) = j < 13           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 26 ] ) = j < 14           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 14 ) ) ;
							*( ( DWORD * )RGBA[ 27 ] ) = j + 13 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 13 ) ) ;
							*( ( DWORD * )RGBA[ 28 ] ) = j + 14 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 14 ) ) ;
							*( ( DWORD * )RGBA[ 29 ] ) = j < 15           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 15 ) ) ;
							*( ( DWORD * )RGBA[ 30 ] ) = j < 16           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 16 ) ) ;
							*( ( DWORD * )RGBA[ 31 ] ) = j + 15 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 15 ) ) ;
							*( ( DWORD * )RGBA[ 32 ] ) = j + 16 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 16 ) ) ;
							*( ( DWORD * )RGBA[ 33 ] ) = j < 17           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 17 ) ) ;
							*( ( DWORD * )RGBA[ 34 ] ) = j < 18           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 18 ) ) ;
							*( ( DWORD * )RGBA[ 35 ] ) = j + 17 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 17 ) ) ;
							*( ( DWORD * )RGBA[ 36 ] ) = j + 18 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 18 ) ) ;
							*( ( DWORD * )RGBA[ 37 ] ) = j < 19           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 19 ) ) ;
							*( ( DWORD * )RGBA[ 38 ] ) = j < 20           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 20 ) ) ;
							*( ( DWORD * )RGBA[ 39 ] ) = j + 19 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 19 ) ) ;
							*( ( DWORD * )RGBA[ 40 ] ) = j + 20 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 20 ) ) ;
							*( ( DWORD * )RGBA[ 41 ] ) = j < 21           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 21 ) ) ;
							*( ( DWORD * )RGBA[ 42 ] ) = j < 22           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 22 ) ) ;
							*( ( DWORD * )RGBA[ 43 ] ) = j + 21 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 21 ) ) ;
							*( ( DWORD * )RGBA[ 44 ] ) = j + 22 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 22 ) ) ;
							*( ( DWORD * )RGBA[ 45 ] ) = j < 23           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 23 ) ) ;
							*( ( DWORD * )RGBA[ 46 ] ) = j < 24           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 24 ) ) ;
							*( ( DWORD * )RGBA[ 47 ] ) = j + 23 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 23 ) ) ;
							*( ( DWORD * )RGBA[ 48 ] ) = j + 24 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 24 ) ) ;
							*( ( DWORD * )RGBA[ 49 ] ) = j < 25           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 25 ) ) ;
							*( ( DWORD * )RGBA[ 50 ] ) = j < 26           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 26 ) ) ;
							*( ( DWORD * )RGBA[ 51 ] ) = j + 25 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 25 ) ) ;
							*( ( DWORD * )RGBA[ 52 ] ) = j + 26 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 26 ) ) ;
							*( ( DWORD * )RGBA[ 53 ] ) = j < 27           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 27 ) ) ;
							*( ( DWORD * )RGBA[ 54 ] ) = j < 28           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 28 ) ) ;
							*( ( DWORD * )RGBA[ 55 ] ) = j + 27 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 27 ) ) ;
							*( ( DWORD * )RGBA[ 56 ] ) = j + 28 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 28 ) ) ;
							*( ( DWORD * )RGBA[ 57 ] ) = j < 29           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 29 ) ) ;
							*( ( DWORD * )RGBA[ 58 ] ) = j < 30           ? *( ( DWORD * )MinSrc ) : *( ( DWORD * )( Src - SrcPitch * 30 ) ) ;
							*( ( DWORD * )RGBA[ 59 ] ) = j + 29 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 29 ) ) ;
							*( ( DWORD * )RGBA[ 60 ] ) = j + 30 >= Height ? *( ( DWORD * )MaxSrc ) : *( ( DWORD * )( Src + SrcPitch * 30 ) ) ;

							Dest[ 0 ] = ( BYTE )(
								( RGBA[ 0 ][ 0 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 0 ] + RGBA[  2 ][ 0 ] + RGBA[  3 ][ 0 ] + RGBA[  4 ][ 0 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 0 ] + RGBA[  6 ][ 0 ] + RGBA[  7 ][ 0 ] + RGBA[  8 ][ 0 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 0 ] + RGBA[ 10 ][ 0 ] + RGBA[ 11 ][ 0 ] + RGBA[ 12 ][ 0 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 0 ] + RGBA[ 14 ][ 0 ] + RGBA[ 15 ][ 0 ] + RGBA[ 16 ][ 0 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 0 ] + RGBA[ 18 ][ 0 ] + RGBA[ 19 ][ 0 ] + RGBA[ 20 ][ 0 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 0 ] + RGBA[ 22 ][ 0 ] + RGBA[ 23 ][ 0 ] + RGBA[ 24 ][ 0 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 0 ] + RGBA[ 26 ][ 0 ] + RGBA[ 27 ][ 0 ] + RGBA[ 28 ][ 0 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 0 ] + RGBA[ 30 ][ 0 ] + RGBA[ 31 ][ 0 ] + RGBA[ 32 ][ 0 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 0 ] + RGBA[ 34 ][ 0 ] + RGBA[ 35 ][ 0 ] + RGBA[ 36 ][ 0 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 0 ] + RGBA[ 38 ][ 0 ] + RGBA[ 39 ][ 0 ] + RGBA[ 40 ][ 0 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 0 ] + RGBA[ 42 ][ 0 ] + RGBA[ 43 ][ 0 ] + RGBA[ 44 ][ 0 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 0 ] + RGBA[ 46 ][ 0 ] + RGBA[ 47 ][ 0 ] + RGBA[ 48 ][ 0 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 0 ] + RGBA[ 50 ][ 0 ] + RGBA[ 51 ][ 0 ] + RGBA[ 52 ][ 0 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 0 ] + RGBA[ 54 ][ 0 ] + RGBA[ 55 ][ 0 ] + RGBA[ 56 ][ 0 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 0 ] + RGBA[ 58 ][ 0 ] + RGBA[ 59 ][ 0 ] + RGBA[ 60 ][ 0 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 1 ] = ( BYTE )(
								( RGBA[ 0 ][ 1 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 1 ] + RGBA[  2 ][ 1 ] + RGBA[  3 ][ 1 ] + RGBA[  4 ][ 1 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 1 ] + RGBA[  6 ][ 1 ] + RGBA[  7 ][ 1 ] + RGBA[  8 ][ 1 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 1 ] + RGBA[ 10 ][ 1 ] + RGBA[ 11 ][ 1 ] + RGBA[ 12 ][ 1 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 1 ] + RGBA[ 14 ][ 1 ] + RGBA[ 15 ][ 1 ] + RGBA[ 16 ][ 1 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 1 ] + RGBA[ 18 ][ 1 ] + RGBA[ 19 ][ 1 ] + RGBA[ 20 ][ 1 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 1 ] + RGBA[ 22 ][ 1 ] + RGBA[ 23 ][ 1 ] + RGBA[ 24 ][ 1 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 1 ] + RGBA[ 26 ][ 1 ] + RGBA[ 27 ][ 1 ] + RGBA[ 28 ][ 1 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 1 ] + RGBA[ 30 ][ 1 ] + RGBA[ 31 ][ 1 ] + RGBA[ 32 ][ 1 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 1 ] + RGBA[ 34 ][ 1 ] + RGBA[ 35 ][ 1 ] + RGBA[ 36 ][ 1 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 1 ] + RGBA[ 38 ][ 1 ] + RGBA[ 39 ][ 1 ] + RGBA[ 40 ][ 1 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 1 ] + RGBA[ 42 ][ 1 ] + RGBA[ 43 ][ 1 ] + RGBA[ 44 ][ 1 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 1 ] + RGBA[ 46 ][ 1 ] + RGBA[ 47 ][ 1 ] + RGBA[ 48 ][ 1 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 1 ] + RGBA[ 50 ][ 1 ] + RGBA[ 51 ][ 1 ] + RGBA[ 52 ][ 1 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 1 ] + RGBA[ 54 ][ 1 ] + RGBA[ 55 ][ 1 ] + RGBA[ 56 ][ 1 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 1 ] + RGBA[ 58 ][ 1 ] + RGBA[ 59 ][ 1 ] + RGBA[ 60 ][ 1 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 2 ] = ( BYTE )(
								( RGBA[ 0 ][ 2 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 2 ] + RGBA[  2 ][ 2 ] + RGBA[  3 ][ 2 ] + RGBA[  4 ][ 2 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 2 ] + RGBA[  6 ][ 2 ] + RGBA[  7 ][ 2 ] + RGBA[  8 ][ 2 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 2 ] + RGBA[ 10 ][ 2 ] + RGBA[ 11 ][ 2 ] + RGBA[ 12 ][ 2 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 2 ] + RGBA[ 14 ][ 2 ] + RGBA[ 15 ][ 2 ] + RGBA[ 16 ][ 2 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 2 ] + RGBA[ 18 ][ 2 ] + RGBA[ 19 ][ 2 ] + RGBA[ 20 ][ 2 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 2 ] + RGBA[ 22 ][ 2 ] + RGBA[ 23 ][ 2 ] + RGBA[ 24 ][ 2 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 2 ] + RGBA[ 26 ][ 2 ] + RGBA[ 27 ][ 2 ] + RGBA[ 28 ][ 2 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 2 ] + RGBA[ 30 ][ 2 ] + RGBA[ 31 ][ 2 ] + RGBA[ 32 ][ 2 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 2 ] + RGBA[ 34 ][ 2 ] + RGBA[ 35 ][ 2 ] + RGBA[ 36 ][ 2 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 2 ] + RGBA[ 38 ][ 2 ] + RGBA[ 39 ][ 2 ] + RGBA[ 40 ][ 2 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 2 ] + RGBA[ 42 ][ 2 ] + RGBA[ 43 ][ 2 ] + RGBA[ 44 ][ 2 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 2 ] + RGBA[ 46 ][ 2 ] + RGBA[ 47 ][ 2 ] + RGBA[ 48 ][ 2 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 2 ] + RGBA[ 50 ][ 2 ] + RGBA[ 51 ][ 2 ] + RGBA[ 52 ][ 2 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 2 ] + RGBA[ 54 ][ 2 ] + RGBA[ 55 ][ 2 ] + RGBA[ 56 ][ 2 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 2 ] + RGBA[ 58 ][ 2 ] + RGBA[ 59 ][ 2 ] + RGBA[ 60 ][ 2 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							Dest[ 3 ] = ( BYTE )(
								( RGBA[ 0 ][ 3 ] * iTable[ 0 ] +
								  ( ( ( RGBA[  1 ][ 3 ] + RGBA[  2 ][ 3 ] + RGBA[  3 ][ 3 ] + RGBA[  4 ][ 3 ] ) * iTable[  1 ] +
									  ( RGBA[  5 ][ 3 ] + RGBA[  6 ][ 3 ] + RGBA[  7 ][ 3 ] + RGBA[  8 ][ 3 ] ) * iTable[  2 ] +
									  ( RGBA[  9 ][ 3 ] + RGBA[ 10 ][ 3 ] + RGBA[ 11 ][ 3 ] + RGBA[ 12 ][ 3 ] ) * iTable[  3 ] +
									  ( RGBA[ 13 ][ 3 ] + RGBA[ 14 ][ 3 ] + RGBA[ 15 ][ 3 ] + RGBA[ 16 ][ 3 ] ) * iTable[  4 ] +
									  ( RGBA[ 17 ][ 3 ] + RGBA[ 18 ][ 3 ] + RGBA[ 19 ][ 3 ] + RGBA[ 20 ][ 3 ] ) * iTable[  5 ] +
									  ( RGBA[ 21 ][ 3 ] + RGBA[ 22 ][ 3 ] + RGBA[ 23 ][ 3 ] + RGBA[ 24 ][ 3 ] ) * iTable[  6 ] +
									  ( RGBA[ 25 ][ 3 ] + RGBA[ 26 ][ 3 ] + RGBA[ 27 ][ 3 ] + RGBA[ 28 ][ 3 ] ) * iTable[  7 ] +
									  ( RGBA[ 29 ][ 3 ] + RGBA[ 30 ][ 3 ] + RGBA[ 31 ][ 3 ] + RGBA[ 32 ][ 3 ] ) * iTable[  8 ] +
									  ( RGBA[ 33 ][ 3 ] + RGBA[ 34 ][ 3 ] + RGBA[ 35 ][ 3 ] + RGBA[ 36 ][ 3 ] ) * iTable[  9 ] +
									  ( RGBA[ 37 ][ 3 ] + RGBA[ 38 ][ 3 ] + RGBA[ 39 ][ 3 ] + RGBA[ 40 ][ 3 ] ) * iTable[ 10 ] +
									  ( RGBA[ 41 ][ 3 ] + RGBA[ 42 ][ 3 ] + RGBA[ 43 ][ 3 ] + RGBA[ 44 ][ 3 ] ) * iTable[ 11 ] +
									  ( RGBA[ 45 ][ 3 ] + RGBA[ 46 ][ 3 ] + RGBA[ 47 ][ 3 ] + RGBA[ 48 ][ 3 ] ) * iTable[ 12 ] +
									  ( RGBA[ 49 ][ 3 ] + RGBA[ 50 ][ 3 ] + RGBA[ 51 ][ 3 ] + RGBA[ 52 ][ 3 ] ) * iTable[ 13 ] +
									  ( RGBA[ 53 ][ 3 ] + RGBA[ 54 ][ 3 ] + RGBA[ 55 ][ 3 ] + RGBA[ 56 ][ 3 ] ) * iTable[ 14 ] +
									  ( RGBA[ 57 ][ 3 ] + RGBA[ 58 ][ 3 ] + RGBA[ 59 ][ 3 ] + RGBA[ 60 ][ 3 ] ) * iTable[ 15 ] ) >> 1 ) ) >> 16 ) ;

							MinSrc += 4 ;
							MaxSrc += 4 ;
							Src  += 4 ;
							Dest += 4 ;
						}

						Src  += SrcAddPitch ;
						Dest += DestAddPitch ;
					}
					break ;
				}

				NS_ReleaseBaseImage( &WorkImage ) ;
			}
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int GraphFilter_Down_Scale( GRAPHFILTER_INFO *Info, int DivNum )
{
	// p[^␳
	if( DivNum <= 2 )
	{
		DivNum = 2 ;
	}
	else
	if( DivNum <= 4 )
	{
		DivNum = 4 ;
	}
	else
	{
		DivNum = 8 ;
	}

	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_Down_Scale_PF( Info, DivNum ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD SrcWidth ;
		DWORD SrcHeight ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcPitch ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		SrcWidth  = Info->SrcX2 - Info->SrcX1 ;
		SrcHeight = Info->SrcY2 - Info->SrcY1 ;
		Width  = SrcWidth  / DivNum ;
		Height = SrcHeight / DivNum ;

		if( GraphFilter_SoftImageSetup( Info, TRUE, Width, Height ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		SrcPitch = Info->SrcImage.Pitch ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		switch( DivNum )
		{
		case 2 :
			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 * 2 + SrcPitch ;

			do
			{
				i = Width ;
				do
				{
					Dest[ 0 ] = ( Src[ 0 ] + Src[ 4 ] + Src[ SrcPitch + 0 ] + Src[ SrcPitch + 4 ] ) >> 2 ;
					Dest[ 1 ] = ( Src[ 1 ] + Src[ 5 ] + Src[ SrcPitch + 1 ] + Src[ SrcPitch + 5 ] ) >> 2 ;
					Dest[ 2 ] = ( Src[ 2 ] + Src[ 6 ] + Src[ SrcPitch + 2 ] + Src[ SrcPitch + 6 ] ) >> 2 ;
					Dest[ 3 ] = ( Src[ 3 ] + Src[ 7 ] + Src[ SrcPitch + 3 ] + Src[ SrcPitch + 7 ] ) >> 2 ;

					Src  += 4 * 2 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
			break ;

		case 4 :
			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 * 4 + SrcPitch * 3 ;

			do
			{
				i = Width ;
				do
				{
					Dest[ 0 ] = (
						Src[                0 ] + Src[                4 ] + Src[                 8 ] + Src[                12 ] +
						Src[ SrcPitch     + 0 ] + Src[ SrcPitch     + 4 ] +	Src[ SrcPitch     +  8 ] + Src[ SrcPitch     + 12 ] +
						Src[ SrcPitch * 2 + 0 ] + Src[ SrcPitch * 2 + 4 ] +	Src[ SrcPitch * 2 +  8 ] + Src[ SrcPitch * 2 + 12 ] +
						Src[ SrcPitch * 3 + 0 ] + Src[ SrcPitch * 3 + 4 ] +	Src[ SrcPitch * 3 +  8 ] + Src[ SrcPitch * 3 + 12 ] ) >> 4 ;
					Dest[ 1 ] = (
						Src[                1 ] + Src[                5 ] + Src[                 9 ] + Src[                13 ] +
						Src[ SrcPitch     + 1 ] + Src[ SrcPitch     + 5 ] +	Src[ SrcPitch     +  9 ] + Src[ SrcPitch     + 13 ] +
						Src[ SrcPitch * 2 + 1 ] + Src[ SrcPitch * 2 + 5 ] +	Src[ SrcPitch * 2 +  9 ] + Src[ SrcPitch * 2 + 13 ] +
						Src[ SrcPitch * 3 + 1 ] + Src[ SrcPitch * 3 + 5 ] +	Src[ SrcPitch * 3 +  9 ] + Src[ SrcPitch * 3 + 13 ] ) >> 4 ;
					Dest[ 2 ] = (
						Src[                2 ] + Src[                6 ] + Src[                10 ] + Src[                14 ] +
						Src[ SrcPitch     + 2 ] + Src[ SrcPitch     + 6 ] +	Src[ SrcPitch     + 10 ] + Src[ SrcPitch     + 14 ] +
						Src[ SrcPitch * 2 + 2 ] + Src[ SrcPitch * 2 + 6 ] +	Src[ SrcPitch * 2 + 10 ] + Src[ SrcPitch * 2 + 14 ] +
						Src[ SrcPitch * 3 + 2 ] + Src[ SrcPitch * 3 + 6 ] +	Src[ SrcPitch * 3 + 10 ] + Src[ SrcPitch * 3 + 14 ] ) >> 4 ;
					Dest[ 3 ] = (
						Src[                3 ] + Src[                7 ] + Src[                11 ] + Src[                15 ] +
						Src[ SrcPitch     + 3 ] + Src[ SrcPitch     + 7 ] +	Src[ SrcPitch     + 11 ] + Src[ SrcPitch     + 15 ] +
						Src[ SrcPitch * 2 + 3 ] + Src[ SrcPitch * 2 + 7 ] +	Src[ SrcPitch * 2 + 11 ] + Src[ SrcPitch * 2 + 15 ] +
						Src[ SrcPitch * 3 + 3 ] + Src[ SrcPitch * 3 + 7 ] +	Src[ SrcPitch * 3 + 11 ] + Src[ SrcPitch * 3 + 15 ] ) >> 4 ;

					Src  += 4 * 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
			break ;

		case 8 :
			SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 * 8 + SrcPitch * 7 ;

			do
			{
				i = Width ;
				do
				{
					Dest[ 0 ] = (
						Src[                0 ] + Src[                4 ] + Src[                 8 ] + Src[                12 ] + Src[                16 ] + Src[                20 ] + Src[                24 ] + Src[                28 ] +
						Src[ SrcPitch     + 0 ] + Src[ SrcPitch     + 4 ] +	Src[ SrcPitch     +  8 ] + Src[ SrcPitch     + 12 ] + Src[ SrcPitch     + 16 ] + Src[ SrcPitch     + 20 ] + Src[ SrcPitch     + 24 ] + Src[ SrcPitch     + 28 ] +
						Src[ SrcPitch * 2 + 0 ] + Src[ SrcPitch * 2 + 4 ] +	Src[ SrcPitch * 2 +  8 ] + Src[ SrcPitch * 2 + 12 ] + Src[ SrcPitch * 2 + 16 ] + Src[ SrcPitch * 2 + 20 ] + Src[ SrcPitch * 2 + 24 ] + Src[ SrcPitch * 2 + 28 ] +
						Src[ SrcPitch * 3 + 0 ] + Src[ SrcPitch * 3 + 4 ] +	Src[ SrcPitch * 3 +  8 ] + Src[ SrcPitch * 3 + 12 ] + Src[ SrcPitch * 3 + 16 ] + Src[ SrcPitch * 3 + 20 ] + Src[ SrcPitch * 3 + 24 ] + Src[ SrcPitch * 3 + 28 ] +
						Src[ SrcPitch * 4 + 0 ] + Src[ SrcPitch * 4 + 4 ] +	Src[ SrcPitch * 4 +  8 ] + Src[ SrcPitch * 4 + 12 ] + Src[ SrcPitch * 4 + 16 ] + Src[ SrcPitch * 4 + 20 ] + Src[ SrcPitch * 4 + 24 ] + Src[ SrcPitch * 4 + 28 ] +
						Src[ SrcPitch * 5 + 0 ] + Src[ SrcPitch * 5 + 4 ] +	Src[ SrcPitch * 5 +  8 ] + Src[ SrcPitch * 5 + 12 ] + Src[ SrcPitch * 5 + 16 ] + Src[ SrcPitch * 5 + 20 ] + Src[ SrcPitch * 5 + 24 ] + Src[ SrcPitch * 5 + 28 ] +
						Src[ SrcPitch * 6 + 0 ] + Src[ SrcPitch * 6 + 4 ] +	Src[ SrcPitch * 6 +  8 ] + Src[ SrcPitch * 6 + 12 ] + Src[ SrcPitch * 6 + 16 ] + Src[ SrcPitch * 6 + 20 ] + Src[ SrcPitch * 6 + 24 ] + Src[ SrcPitch * 6 + 28 ] +
						Src[ SrcPitch * 7 + 0 ] + Src[ SrcPitch * 7 + 4 ] +	Src[ SrcPitch * 7 +  8 ] + Src[ SrcPitch * 7 + 12 ] + Src[ SrcPitch * 7 + 16 ] + Src[ SrcPitch * 7 + 20 ] + Src[ SrcPitch * 7 + 24 ] + Src[ SrcPitch * 7 + 28 ] ) >> 6 ;
					Dest[ 1 ] = (
						Src[                1 ] + Src[                5 ] + Src[                 9 ] + Src[                13 ] + Src[                17 ] + Src[                21 ] + Src[                25 ] + Src[                29 ] +
						Src[ SrcPitch     + 1 ] + Src[ SrcPitch     + 5 ] +	Src[ SrcPitch     +  9 ] + Src[ SrcPitch     + 13 ] + Src[ SrcPitch     + 17 ] + Src[ SrcPitch     + 21 ] + Src[ SrcPitch     + 25 ] + Src[ SrcPitch     + 29 ] +
						Src[ SrcPitch * 2 + 1 ] + Src[ SrcPitch * 2 + 5 ] +	Src[ SrcPitch * 2 +  9 ] + Src[ SrcPitch * 2 + 13 ] + Src[ SrcPitch * 2 + 17 ] + Src[ SrcPitch * 2 + 21 ] + Src[ SrcPitch * 2 + 25 ] + Src[ SrcPitch * 2 + 29 ] +
						Src[ SrcPitch * 3 + 1 ] + Src[ SrcPitch * 3 + 5 ] +	Src[ SrcPitch * 3 +  9 ] + Src[ SrcPitch * 3 + 13 ] + Src[ SrcPitch * 3 + 17 ] + Src[ SrcPitch * 3 + 21 ] + Src[ SrcPitch * 3 + 25 ] + Src[ SrcPitch * 3 + 29 ] +
						Src[ SrcPitch * 4 + 1 ] + Src[ SrcPitch * 4 + 5 ] +	Src[ SrcPitch * 4 +  9 ] + Src[ SrcPitch * 4 + 13 ] + Src[ SrcPitch * 4 + 17 ] + Src[ SrcPitch * 4 + 21 ] + Src[ SrcPitch * 4 + 25 ] + Src[ SrcPitch * 4 + 29 ] +
						Src[ SrcPitch * 5 + 1 ] + Src[ SrcPitch * 5 + 5 ] +	Src[ SrcPitch * 5 +  9 ] + Src[ SrcPitch * 5 + 13 ] + Src[ SrcPitch * 5 + 17 ] + Src[ SrcPitch * 5 + 21 ] + Src[ SrcPitch * 5 + 25 ] + Src[ SrcPitch * 5 + 29 ] +
						Src[ SrcPitch * 6 + 1 ] + Src[ SrcPitch * 6 + 5 ] +	Src[ SrcPitch * 6 +  9 ] + Src[ SrcPitch * 6 + 13 ] + Src[ SrcPitch * 6 + 17 ] + Src[ SrcPitch * 6 + 21 ] + Src[ SrcPitch * 6 + 25 ] + Src[ SrcPitch * 6 + 29 ] +
						Src[ SrcPitch * 7 + 1 ] + Src[ SrcPitch * 7 + 5 ] +	Src[ SrcPitch * 7 +  9 ] + Src[ SrcPitch * 7 + 13 ] + Src[ SrcPitch * 7 + 17 ] + Src[ SrcPitch * 7 + 21 ] + Src[ SrcPitch * 7 + 25 ] + Src[ SrcPitch * 7 + 29 ] ) >> 6 ;
					Dest[ 2 ] = (
						Src[                2 ] + Src[                6 ] + Src[                10 ] + Src[                14 ] + Src[                18 ] + Src[                22 ] + Src[                26 ] + Src[                30 ] +
						Src[ SrcPitch     + 2 ] + Src[ SrcPitch     + 6 ] +	Src[ SrcPitch     + 10 ] + Src[ SrcPitch     + 14 ] + Src[ SrcPitch     + 18 ] + Src[ SrcPitch     + 22 ] + Src[ SrcPitch     + 26 ] + Src[ SrcPitch     + 30 ] +
						Src[ SrcPitch * 2 + 2 ] + Src[ SrcPitch * 2 + 6 ] +	Src[ SrcPitch * 2 + 10 ] + Src[ SrcPitch * 2 + 14 ] + Src[ SrcPitch * 2 + 18 ] + Src[ SrcPitch * 2 + 22 ] + Src[ SrcPitch * 2 + 26 ] + Src[ SrcPitch * 2 + 30 ] +
						Src[ SrcPitch * 3 + 2 ] + Src[ SrcPitch * 3 + 6 ] +	Src[ SrcPitch * 3 + 10 ] + Src[ SrcPitch * 3 + 14 ] + Src[ SrcPitch * 3 + 18 ] + Src[ SrcPitch * 3 + 22 ] + Src[ SrcPitch * 3 + 26 ] + Src[ SrcPitch * 3 + 30 ] +
						Src[ SrcPitch * 4 + 2 ] + Src[ SrcPitch * 4 + 6 ] +	Src[ SrcPitch * 4 + 10 ] + Src[ SrcPitch * 4 + 14 ] + Src[ SrcPitch * 4 + 18 ] + Src[ SrcPitch * 4 + 22 ] + Src[ SrcPitch * 4 + 26 ] + Src[ SrcPitch * 4 + 30 ] +
						Src[ SrcPitch * 5 + 2 ] + Src[ SrcPitch * 5 + 6 ] +	Src[ SrcPitch * 5 + 10 ] + Src[ SrcPitch * 5 + 14 ] + Src[ SrcPitch * 5 + 18 ] + Src[ SrcPitch * 5 + 22 ] + Src[ SrcPitch * 5 + 26 ] + Src[ SrcPitch * 5 + 30 ] +
						Src[ SrcPitch * 6 + 2 ] + Src[ SrcPitch * 6 + 6 ] +	Src[ SrcPitch * 6 + 10 ] + Src[ SrcPitch * 6 + 14 ] + Src[ SrcPitch * 6 + 18 ] + Src[ SrcPitch * 6 + 22 ] + Src[ SrcPitch * 6 + 26 ] + Src[ SrcPitch * 6 + 30 ] +
						Src[ SrcPitch * 7 + 2 ] + Src[ SrcPitch * 7 + 6 ] +	Src[ SrcPitch * 7 + 10 ] + Src[ SrcPitch * 7 + 14 ] + Src[ SrcPitch * 7 + 18 ] + Src[ SrcPitch * 7 + 22 ] + Src[ SrcPitch * 7 + 26 ] + Src[ SrcPitch * 7 + 30 ] ) >> 6 ;
					Dest[ 3 ] = (
						Src[                3 ] + Src[                7 ] + Src[                11 ] + Src[                15 ] + Src[                19 ] + Src[                23 ] + Src[                27 ] + Src[                31 ] +
						Src[ SrcPitch     + 3 ] + Src[ SrcPitch     + 7 ] +	Src[ SrcPitch     + 11 ] + Src[ SrcPitch     + 15 ] + Src[ SrcPitch     + 19 ] + Src[ SrcPitch     + 23 ] + Src[ SrcPitch     + 27 ] + Src[ SrcPitch     + 31 ] +
						Src[ SrcPitch * 2 + 3 ] + Src[ SrcPitch * 2 + 7 ] +	Src[ SrcPitch * 2 + 11 ] + Src[ SrcPitch * 2 + 15 ] + Src[ SrcPitch * 2 + 19 ] + Src[ SrcPitch * 2 + 23 ] + Src[ SrcPitch * 2 + 27 ] + Src[ SrcPitch * 2 + 31 ] +
						Src[ SrcPitch * 3 + 3 ] + Src[ SrcPitch * 3 + 7 ] +	Src[ SrcPitch * 3 + 11 ] + Src[ SrcPitch * 3 + 15 ] + Src[ SrcPitch * 3 + 19 ] + Src[ SrcPitch * 3 + 23 ] + Src[ SrcPitch * 3 + 27 ] + Src[ SrcPitch * 3 + 31 ] +
						Src[ SrcPitch * 4 + 3 ] + Src[ SrcPitch * 4 + 7 ] +	Src[ SrcPitch * 4 + 11 ] + Src[ SrcPitch * 4 + 15 ] + Src[ SrcPitch * 4 + 19 ] + Src[ SrcPitch * 4 + 23 ] + Src[ SrcPitch * 4 + 27 ] + Src[ SrcPitch * 4 + 31 ] +
						Src[ SrcPitch * 5 + 3 ] + Src[ SrcPitch * 5 + 7 ] +	Src[ SrcPitch * 5 + 11 ] + Src[ SrcPitch * 5 + 15 ] + Src[ SrcPitch * 5 + 19 ] + Src[ SrcPitch * 5 + 23 ] + Src[ SrcPitch * 5 + 27 ] + Src[ SrcPitch * 5 + 31 ] +
						Src[ SrcPitch * 6 + 3 ] + Src[ SrcPitch * 6 + 7 ] +	Src[ SrcPitch * 6 + 11 ] + Src[ SrcPitch * 6 + 15 ] + Src[ SrcPitch * 6 + 19 ] + Src[ SrcPitch * 6 + 23 ] + Src[ SrcPitch * 6 + 27 ] + Src[ SrcPitch * 6 + 31 ] +
						Src[ SrcPitch * 7 + 3 ] + Src[ SrcPitch * 7 + 7 ] +	Src[ SrcPitch * 7 + 11 ] + Src[ SrcPitch * 7 + 15 ] + Src[ SrcPitch * 7 + 19 ] + Src[ SrcPitch * 7 + 23 ] + Src[ SrcPitch * 7 + 27 ] + Src[ SrcPitch * 7 + 31 ] ) >> 6 ;

					Src  += 4 * 8 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
			break ;
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

// CmpType:r^Cv( DX_CMP_LESS  DX_CMP_GREATER ̂ݎwł܂ )
// CmpParam:rl( 0.0f`255.0f )
// ClipFillFlag:NbvsNZ̐FœhԂ( TRUE:hԂ  FALSE:hԂȂ )
// ClipFillColor:NbvsNZɓhF( GetColorFŎ擾 )
extern int GraphFilter_Bright_Clip( GRAPHFILTER_INFO *Info, int CmpType, float CmpParam, int ClipFillFlag, COLOR_F *ClipFillColor )
{
	// l̕␳
	if( CmpType != DX_CMP_LESS && CmpType != DX_CMP_GREATER )
		return -1 ;

	if( ClipFillFlag == TRUE && ClipFillColor == NULL )
		return -1 ;

	CmpParam /= 255.0f ;
	if( CmpParam < 0.0f )
	{
		CmpParam = 0.0f ;
	}
	else
	if( CmpParam > 1.0f )
	{
		CmpParam = 1.0f ;
	}

	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_Bright_Clip_PF( Info, CmpType, CmpParam, ClipFillFlag, ClipFillColor ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int Temp ;
		BYTE iClipFillColor[ 4 ] ;
		int iCmpParam ;

		iCmpParam = _FTOL( CmpParam * 255.0f * 4096.0f ) ;

		if( ClipFillColor != NULL )
		{
			Temp = _FTOL( ClipFillColor->b * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 0 ] = ( BYTE )Temp ;

			Temp = _FTOL( ClipFillColor->g * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 1 ] = ( BYTE )Temp ;

			Temp = _FTOL( ClipFillColor->r * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 2 ] = ( BYTE )Temp ;

			Temp = _FTOL( ClipFillColor->a * 255.0f ) ;
			if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
			iClipFillColor[ 3 ] = ( BYTE )Temp ;
		}

		if( GraphFilter_SoftImageSetup( Info, FALSE ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		if( ClipFillFlag )
		{
			if( CmpType == DX_CMP_GREATER )
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) > iCmpParam )
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )iClipFillColor ) ;
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
			else
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) < iCmpParam )
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )iClipFillColor ) ;
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
		}
		else
		{
			if( CmpType == DX_CMP_GREATER )
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) > iCmpParam )
						{
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
			else
			{
				do
				{
					i = Width ;
					do
					{
						if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
							Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
							Src[ 2 ] * ( int )( 0.299f * 4096.0f ) < iCmpParam )
						{
						}
						else
						{
							*( ( DWORD * )Dest ) = *( ( DWORD * )Src ) ;
						}

						Src  += 4 ;
						Dest += 4 ;
					}while( -- i ) ;

					Src  += SrcAddPitch ;
					Dest += DestAddPitch ;
				}while( -- Height ) ;
			}
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int GraphFilter_HSB( GRAPHFILTER_INFO *Info, int HueType, float Hue, float Saturation, float Bright )
{
	// l␳
	Hue = Hue / 360.0f ;
	if( HueType == 0 )
	{
		if( Hue < -0.5f )
		{
			Hue = -0.5f;
		}
		else
		if( Hue > 0.5f )
		{
			Hue = 0.5f;
		}
	}
	else
	{
		if( Hue < 0.0f )
		{
			Hue = 0.0f;
		}
		else
		if( Hue > 1.0f )
		{
			Hue = 1.0f;
		}
	}
	Hue *= 6.0f ;
	Saturation /= 100.0f;
	if( Saturation < -1.0f )
	{
		Saturation = -1.0f;
	}
	else
	if( Saturation > 1.0f )
	{
		Saturation = 1.0f;
	}
	Bright /= 100.0f;

	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_HSB_PF( Info, HueType, Hue, Saturation, Bright ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int iHue ;
		int iSaturation ;
		int iBright ;
		int iH, iS, iB ;
		int Max ;
		int Min ;
		int Delta ;
		int R, G, B ;

		iHue        = _FTOL( Hue        * 256.0f ) ;
		iSaturation = _FTOL( ( Saturation > 0.0f ? Saturation * 5.0f : Saturation ) * 256.0f ) ;
		iBright     = _FTOL( Bright     * 256.0f ) ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		if( HueType == 1 )
		{
			if( iHue >= 0x600 )
			{
				iHue -= 0x600 ;
			}
			do
			{
				i = Width ;
				do
				{
					B = Src[ 0 ] ;
					G = Src[ 1 ] ;
					R = Src[ 2 ] ;

					if( iBright > 0 )
					{
						B += ( ( 255 - B ) * iBright ) >> 8 ;
						G += ( ( 255 - G ) * iBright ) >> 8 ;
						R += ( ( 255 - R ) * iBright ) >> 8 ;
					}
					else
					{
						B = ( B * ( 256 + iBright ) ) >> 8 ;
						G = ( G * ( 256 + iBright ) ) >> 8 ;
						R = ( R * ( 256 + iBright ) ) >> 8 ;
					}

					Max = R > G ? ( R > B ? R : B ) : ( G > B ? G : B ) ;
					Min = R < G ? ( R < B ? R : B ) : ( G < B ? G : B ) ;
					Delta = Max - Min;

					iB = ( Max + Min ) >> 1 ;
					if( Max == Min )
					{
						iS = 0 ;
					}
					else
					{
						if( iB > 128 )
						{
							iS = 512 - Max - Min; 
						}
						else
						{
							iS = Max + Min;
						}
						iS = ( Delta << 8 ) / iS;
					}

					iH = iHue ;

					iS = ( iS * ( 256 + iSaturation ) ) >> 8 ;
					if( iS > 256 ) iS = 256 ;

					int iHM ;
					iHM = iH & 0xff ;

					if( iH < 0x100 )
					{
						R = 255 ;
						G = iHM ;
						B = 0 ;
					}
					else
					if( iH < 0x200 )
					{
						R = 255 - iHM ;
						G = 255 ;
						B = 0 ;
					}
					else
					if( iH < 0x300 )
					{
						R = 0 ;
						G = 255 ;
						B = iHM ;
					}
					else
					if( iH < 0x400 )
					{
						R = 0 ;
						G = 255 - iHM ;
						B = 255 ;
					}
					else
					if( iH < 0x500 )
					{
						R = iHM ;
						G = 0 ;
						B = 255 ;
					}
					else
					{
						R = 255 ;
						G = 0 ;
						B = 255 - iHM ;
					}

					B += ( ( 128 - B ) * ( 256 - iS ) ) >> 8 ;
					G += ( ( 128 - G ) * ( 256 - iS ) ) >> 8 ;
					R += ( ( 128 - R ) * ( 256 - iS ) ) >> 8 ;

					if( iB <= 128 )
					{
						Dest[ 0 ] = ( BYTE )( ( B * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 1 ] = ( BYTE )( ( G * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 2 ] = ( BYTE )( ( R * ( iB << 1 ) ) >> 8 ) ;
					}
					else
					{
						Dest[ 0 ] = ( BYTE )( B + ( ( ( 255 - B ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 1 ] = ( BYTE )( G + ( ( ( 255 - G ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 2 ] = ( BYTE )( R + ( ( ( 255 - R ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
					}

					Dest[ 3 ] = Src[ 3 ] ;

					Src  += 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
		}
		else
		{
			do
			{
				i = Width ;
				do
				{
					B = Src[ 0 ] ;
					G = Src[ 1 ] ;
					R = Src[ 2 ] ;

					if( iBright > 0 )
					{
						B += ( ( 255 - B ) * iBright ) >> 8 ;
						G += ( ( 255 - G ) * iBright ) >> 8 ;
						R += ( ( 255 - R ) * iBright ) >> 8 ;
					}
					else
					{
						B = ( B * ( 256 + iBright ) ) >> 8 ;
						G = ( G * ( 256 + iBright ) ) >> 8 ;
						R = ( R * ( 256 + iBright ) ) >> 8 ;
					}

					Max = R > G ? ( R > B ? R : B ) : ( G > B ? G : B ) ;
					Min = R < G ? ( R < B ? R : B ) : ( G < B ? G : B ) ;
					Delta = Max - Min;

					iB = ( Max + Min ) >> 1 ;
					if( Max == Min )
					{
						iH = 0 ;
						iS = 0 ;
					}
					else
					{
						int tR, tG, tB ;

						if( iB > 128 )
						{
							iS = 512 - Max - Min; 
						}
						else
						{
							iS = Max + Min;
						}
						iS = ( Delta << 8 ) / iS;

						tB = ( ( Max - B ) << 8 ) / Delta ;
						tG = ( ( Max - G ) << 8 ) / Delta ;
						tR = ( ( Max - R ) << 8 ) / Delta ;
						if( R == Max )
						{
							iH = tB - tG ;
						}
						else
						if( G == Max )
						{
							iH = 0x200 + tR - tB ;
						}
						else
						{
							iH = 0x400 + tG - tR ;
						}
						if( iH < 0 )
						{
							iH += 0x600 ;
						}
					}

					iH += iHue ;
					if( iH < 0 )
					{
						iH += 0x600 ;
					}
					else
					if( iH >= 0x600 )
					{
						iH -= 0x600 ;
					}

					iS = ( iS * ( 256 + iSaturation ) ) >> 8 ;
					if( iS > 256 ) iS = 256 ;

					int iHM ;
					iHM = iH & 0xff ;

					if( iH < 0x100 )
					{
						R = 255 ;
						G = iHM ;
						B = 0 ;
					}
					else
					if( iH < 0x200 )
					{
						R = 255 - iHM ;
						G = 255 ;
						B = 0 ;
					}
					else
					if( iH < 0x300 )
					{
						R = 0 ;
						G = 255 ;
						B = iHM ;
					}
					else
					if( iH < 0x400 )
					{
						R = 0 ;
						G = 255 - iHM ;
						B = 255 ;
					}
					else
					if( iH < 0x500 )
					{
						R = iHM ;
						G = 0 ;
						B = 255 ;
					}
					else
					{
						R = 255 ;
						G = 0 ;
						B = 255 - iHM ;
					}

					B += ( ( 128 - B ) * ( 256 - iS ) ) >> 8 ;
					G += ( ( 128 - G ) * ( 256 - iS ) ) >> 8 ;
					R += ( ( 128 - R ) * ( 256 - iS ) ) >> 8 ;

					if( iB <= 128 )
					{
						Dest[ 0 ] = ( BYTE )( ( B * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 1 ] = ( BYTE )( ( G * ( iB << 1 ) ) >> 8 ) ;
						Dest[ 2 ] = ( BYTE )( ( R * ( iB << 1 ) ) >> 8 ) ;
					}
					else
					{
						Dest[ 0 ] = ( BYTE )( B + ( ( ( 255 - B ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 1 ] = ( BYTE )( G + ( ( ( 255 - G ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
						Dest[ 2 ] = ( BYTE )( R + ( ( ( 255 - R ) * ( ( iB - 128 ) << 1 ) ) >> 8 ) ) ;
					}

					Dest[ 3 ] = Src[ 3 ] ;

					Src  += 4 ;
					Dest += 4 ;
				}while( -- i ) ;

				Src  += SrcAddPitch ;
				Dest += DestAddPitch ;
			}while( -- Height ) ;
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int GraphFilter_Invert( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_Invert_PF( Info ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				Dest[ 0 ] = 255 - Src[ 0 ] ;
				Dest[ 1 ] = 255 - Src[ 1 ] ;
				Dest[ 2 ] = 255 - Src[ 2 ] ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int GraphFilter_Level( GRAPHFILTER_INFO *Info, float Min, float Max, float Gamma, float AfterMin, float AfterMax )
{
	// l␳
	Min /= 255.0f ;
	Max /= 255.0f ;
	AfterMin /= 255.0f ;
	AfterMax /= 255.0f ;
	if( Min < 0.0f )
	{
		Min = 0.0f ;
	}
	else
	if( Min > 1.0f )
	{
		Min = 1.0f ;
	}
	if( Max < 0.0f )
	{
		Max = 0.0f ;
	}
	else
	if( Max > 1.0f )
	{
		Max = 1.0f ;
	}
	if( Gamma < 0.001f )
	{
		Gamma = 0.001f ;
	}
	if( AfterMin < 0.0f )
	{
		AfterMin = 0.0f ;
	}
	else
	if( AfterMin > 1.0f )
	{
		AfterMin = 1.0f ;
	}
	if( AfterMax < 0.0f )
	{
		AfterMax = 0.0f ;
	}
	else
	if( AfterMax > 1.0f )
	{
		AfterMax = 1.0f ;
	}
	if( Min > Max ) Min = Max ;
	if( AfterMin > AfterMax ) AfterMin = AfterMax ;

	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_Level_PF( Info, Min, Max, Gamma, AfterMin, AfterMax ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int iMin ;
		int iMax ;
		int iMinMaxLen ;
		int iAfterMin ;
		int iAfterMax ;
		int iAfterMinMaxLen ;
		int iAfterMin256 ;
		int R, G, B ;
		static float PrevGamma = -10000000.0f ;
		static int GammaTable[ 256 ] ;

		if( _FABS( PrevGamma - Gamma ) > 0.0001f )
		{
			int i ;
			float Param ;
			float GammaRev ;

			GammaRev = 1.0f / Gamma ;
			for( i = 0 ; i < 256 ; i ++ )
			{
				Param = _POW( ( float )i / 255.0f, GammaRev ) * 255.0f ;
				if( Param > 255.0f )
				{
					GammaTable[ i ] = 255 ;
				}
				else
				{
					GammaTable[ i ] = _FTOL( Param ) ;
				}
			}

			PrevGamma = Gamma ;
		}

		iMin = _FTOL( Min * 255 ) ;
		iMax = _FTOL( Max * 255 ) ;
		iMinMaxLen = iMax - iMin ;
		iAfterMin = _FTOL( AfterMin * 255 ) ;
		iAfterMax = _FTOL( AfterMax * 255 ) ;
		iAfterMinMaxLen = iAfterMax - iAfterMin ;
		iAfterMin256 = iAfterMin << 8 ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				B = ( ( Src[ 0 ] - iMin ) << 8 ) / iMinMaxLen;
				B = B < 0 ? GammaTable[ 0 ] : ( B > 255 ?  GammaTable[ 255 ] : GammaTable[ B ] ) ;

				G = ( ( Src[ 1 ] - iMin ) << 8 ) / iMinMaxLen;
				G = G < 0 ? GammaTable[ 0 ] : ( G > 255 ?  GammaTable[ 255 ] : GammaTable[ G ] ) ;

				R = ( ( Src[ 2 ] - iMin ) << 8 ) / iMinMaxLen;
				R = R < 0 ? GammaTable[ 0 ] : ( R > 255 ?  GammaTable[ 255 ] : GammaTable[ R ] ) ;

				Dest[ 0 ] = ( BYTE )( ( iAfterMin256 + iAfterMinMaxLen * B ) >> 8 ) ;
				Dest[ 1 ] = ( BYTE )( ( iAfterMin256 + iAfterMinMaxLen * G ) >> 8 ) ;
				Dest[ 2 ] = ( BYTE )( ( iAfterMin256 + iAfterMinMaxLen * R ) >> 8 ) ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int GraphFilter_TwoColor( GRAPHFILTER_INFO *Info, float Threshold, COLOR_F *LowColor, COLOR_F *HighColor )
{
	// l␳
	if( LowColor == NULL || HighColor == NULL )
		return -1 ;

	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_TwoColor_PF( Info, Threshold, LowColor, HighColor ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		int Temp ;
		int iThreshold ;
		BYTE iLowColor[ 4 ] ;
		BYTE iHighColor[ 4 ] ;

		iThreshold = _FTOL( Threshold * 4096.0f ) ;

		Temp = _FTOL( LowColor->b * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 0 ] = ( BYTE )Temp ;

		Temp = _FTOL( LowColor->g * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 1 ] = ( BYTE )Temp ;

		Temp = _FTOL( LowColor->r * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 2 ] = ( BYTE )Temp ;

		Temp = _FTOL( LowColor->a * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iLowColor[ 3 ] = ( BYTE )Temp ;


		Temp = _FTOL( HighColor->b * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 0 ] = ( BYTE )Temp ;

		Temp = _FTOL( HighColor->g * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 1 ] = ( BYTE )Temp ;

		Temp = _FTOL( HighColor->r * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 2 ] = ( BYTE )Temp ;

		Temp = _FTOL( HighColor->a * 255.0f ) ;
		if( Temp < 0 ) Temp = 0 ; else if( Temp > 255 ) Temp = 255 ;
		iHighColor[ 3 ] = ( BYTE )Temp ;


		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				if( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
					Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
					Src[ 2 ] * ( int )( 0.299f * 4096.0f ) < iThreshold )
				{
					*( ( DWORD * )Dest ) = *( ( DWORD * )iLowColor ) ;
				}
				else
				{
					*( ( DWORD * )Dest ) = *( ( DWORD * )iHighColor ) ;
				}

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int	GraphFilter_GradientMap( GRAPHFILTER_INFO *Info, int MapGrHandle, int Reverse )
{
	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_GradientMap_PF( Info, MapGrHandle, Reverse ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;
		BASEIMAGE GradImage ;
		DWORD GradMap[ 256 ] ;

		// Of[V}bv̔zZbgAbv
		{
			int GradWidth, GradHeight ;

			if( NS_GetGraphSize( MapGrHandle, &GradWidth, &GradHeight ) < 0 )
				return -1 ;

			if( GraphFilter_GetSoftImage( MapGrHandle, &GradImage, NULL ) < 0 )
				return -1 ;

			if( Reverse )
			{
				for( i = 0 ; i < 256 ; i ++ )
					GradMap[ 255 - i ] = *( ( DWORD * )( ( BYTE * )GradImage.GraphData + GradWidth * i / 256 * 4 ) ) ;
			}
			else
			{
				for( i = 0 ; i < 256 ; i ++ )
					GradMap[ i ] = *( ( DWORD * )( ( BYTE * )GradImage.GraphData + GradWidth * i / 256 * 4 ) ) ;
			}

			NS_ReleaseBaseImage( &GradImage ) ;
		}

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				*( ( DWORD * )Dest ) = GradMap[ ( Src[ 0 ] * ( int )( 0.114f * 4096.0f ) +
												  Src[ 1 ] * ( int )( 0.587f * 4096.0f ) +
												  Src[ 2 ] * ( int )( 0.299f * 4096.0f ) ) >> 12 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int	GraphFilter_PremulAlpha( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_PremulAlpha_PF( Info ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				Dest[ 0 ] = ( Src[ 0 ] * Src[ 3 ] ) >> 8 ;
				Dest[ 1 ] = ( Src[ 1 ] * Src[ 3 ] ) >> 8 ;
				Dest[ 2 ] = ( Src[ 2 ] * Src[ 3 ] ) >> 8 ;
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int	GraphFilter_InterpAlpha( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphFilter_InterpAlpha_PF( Info ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Dest ;
		DWORD tmp ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch  = Info->SrcImage.Pitch  - Width * 4 ;
		DestAddPitch = Info->DestImage.Pitch - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				if( Src[ 3 ] == 0 )
				{
					Dest[ 0 ] = 0 ;
					Dest[ 1 ] = 0 ;
					Dest[ 2 ] = 0 ;
				}
				else
				{
					tmp = Src[ 0 ] * 255 / Src[ 3 ] ; Dest[ 0 ] = ( BYTE )( tmp > 255 ? 255 : tmp ) ;
					tmp = Src[ 1 ] * 255 / Src[ 3 ] ; Dest[ 1 ] = ( BYTE )( tmp > 255 ? 255 : tmp ) ;
					tmp = Src[ 2 ] * 255 / Src[ 3 ] ; Dest[ 2 ] = ( BYTE )( tmp > 255 ? 255 : tmp ) ;
				}
				Dest[ 3 ] = Src[ 3 ] ;

				Src  += 4 ;
				Dest += 4 ;
			}while( -- i ) ;

			Src  += SrcAddPitch ;
			Dest += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int	GraphBlend_Basic( GRAPHFILTER_INFO *Info )
{
	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphBlend_Basic_PF( Info ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Blend ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD BlendAddPitch ;
		DWORD DestAddPitch ;
		int R, G, B, A ;
		int BlendRatio ;
		int TempBlendRatio ;
		float fRGB[ 4 ] ;
		int iRGB[ 4 ] ;

		fRGB[ 3 ] = 0.0f ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		BlendRatio = _FTOL( Info->BlendRatio * 256.0f ) ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Blend = ( BYTE * )Info->BlendImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch   = Info->SrcImage.Pitch   - Width * 4 ;
		BlendAddPitch = Info->BlendImage.Pitch - Width * 4 ;
		DestAddPitch  = Info->DestImage.Pitch  - Width * 4 ;

		switch( Info->FilterOrBlendType )
		{
		case DX_GRAPH_BLEND_NORMAL :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( Blend[ 0 ] - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( Blend[ 1 ] - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( Blend[ 2 ] - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_MULTIPLE :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = ( Src[ 0 ] * Blend[ 0 ] ) >> 8 ;
						G = ( Src[ 1 ] * Blend[ 1 ] ) >> 8 ;
						R = ( Src[ 2 ] * Blend[ 2 ] ) >> 8 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_DIFFERENCE :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = Src[ 0 ] - Blend[ 0 ] ;
						G = Src[ 1 ] - Blend[ 1 ] ;
						R = Src[ 2 ] - Blend[ 2 ] ;
						if( B < 0 ) B = 0 ;
						if( G < 0 ) G = 0 ;
						if( R < 0 ) R = 0 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_ADD :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = Src[ 0 ] + Blend[ 0 ] ;
						G = Src[ 1 ] + Blend[ 1 ] ;
						R = Src[ 2 ] + Blend[ 2 ] ;
						if( B > 255 ) B = 255 ;
						if( G > 255 ) G = 255 ;
						if( R > 255 ) R = 255 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_SCREEN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;
						B = 255 - ( ( ( 255 - Src[ 0 ] ) * ( 255 - Blend[ 0 ] ) ) >> 8 ) ;
						G = 255 - ( ( ( 255 - Src[ 1 ] ) * ( 255 - Blend[ 1 ] ) ) >> 8 ) ;
						R = 255 - ( ( ( 255 - Src[ 2 ] ) * ( 255 - Blend[ 2 ] ) ) >> 8 ) ;
						if( B > 255 ) B = 255 ;
						if( G > 255 ) G = 255 ;
						if( R > 255 ) R = 255 ;
						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_OVERLAY :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Src[ 0 ] < 128 )
						{
							B = ( Src[ 0 ] * Blend[ 0 ] * 2 ) >> 8 ;
						}
						else
						{
							B = ( ( 2 * ( ( ( Src[ 0 ] + Blend[ 0 ] ) << 8 ) - Src[ 0 ] * Blend[ 0 ] ) ) >> 8 ) - 255 ;
						}
						if( B > 255 ) B = 255 ;

						if( Src[ 1 ] < 128 )
						{
							G = ( Src[ 1 ] * Blend[ 1 ] * 2 ) >> 8 ;
						}
						else
						{
							G = ( ( 2 * ( ( ( Src[ 1 ] + Blend[ 1 ] ) << 8 ) - Src[ 1 ] * Blend[ 1 ] ) ) >> 8 ) - 255 ;
						}
						if( G > 255 ) G = 255 ;

						if( Src[ 2 ] < 128 )
						{
							R = ( Src[ 2 ] * Blend[ 2 ] * 2 ) >> 8 ;
						}
						else
						{
							R = ( ( 2 * ( ( ( Src[ 2 ] + Blend[ 2 ] ) << 8 ) - Src[ 2 ] * Blend[ 2 ] ) ) >> 8 ) - 255 ;
						}
						if( R > 255 ) R = 255 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_DODGE :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Blend[ 0 ] < 255 )
						{
							B = ( Src[ 0 ] << 8 ) / ( 255 - Blend[ 0 ] ) ;
							if( B > 255 ) B = 255 ;
						}
						else
						{
							B = 255 ;
						}

						if( Blend[ 1 ] < 255 )
						{
							G = ( Src[ 1 ] << 8 ) / ( 255 - Blend[ 1 ] ) ;
							if( G > 255 ) G = 255 ;
						}
						else
						{
							G = 255 ;
						}

						if( Blend[ 2 ] < 255 )
						{
							R = ( Src[ 2 ] << 8 ) / ( 255 - Blend[ 2 ] ) ;
							if( R > 255 ) R = 255 ;
						}
						else
						{
							R = 255 ;
						}

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_BURN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = 255 - ( ( 255 - Src[ 0 ] ) << 8 ) / ( Blend[ 0 ] + 1 ) ;
						if( B < 0 ) B = 0 ;

						G = 255 - ( ( 255 - Src[ 1 ] ) << 8 ) / ( Blend[ 1 ] + 1 ) ;
						if( G < 0 ) G = 0 ;

						R = 255 - ( ( 255 - Src[ 2 ] ) << 8 ) / ( Blend[ 2 ] + 1 ) ;
						if( R < 0 ) R = 0 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_DARKEN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = Src[ 0 ] < Blend[ 0 ] ? Src[ 0 ] : Blend[ 0 ] ;
						G = Src[ 1 ] < Blend[ 1 ] ? Src[ 1 ] : Blend[ 1 ] ;
						R = Src[ 2 ] < Blend[ 2 ] ? Src[ 2 ] : Blend[ 2 ] ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_LIGHTEN :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = Src[ 0 ] > Blend[ 0 ] ? Src[ 0 ] : Blend[ 0 ] ;
						G = Src[ 1 ] > Blend[ 1 ] ? Src[ 1 ] : Blend[ 1 ] ;
						R = Src[ 2 ] > Blend[ 2 ] ? Src[ 2 ] : Blend[ 2 ] ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_SOFTLIGHT :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Blend[ 0 ] < 128 )
						{
							fRGB[ 0 ] = _POW( Src[ 0 ] / 255.0f, ( 1.0f - Blend[ 0 ] / 255.0f ) * 2.0f ) ;
						}
						else
						{
							fRGB[ 0 ] = _POW( Src[ 0 ] / 255.0f, 0.5f / ( Blend[ 0 ] / 255.0f ) ) ;
						}

						if( Blend[ 1 ] < 128 )
						{
							fRGB[ 1 ] = _POW( Src[ 1 ] / 255.0f, ( 1.0f - Blend[ 1 ] / 255.0f ) * 2.0f ) ;
						}
						else
						{
							fRGB[ 1 ] = _POW( Src[ 1 ] / 255.0f, 0.5f / ( Blend[ 1 ] / 255.0f ) ) ;
						}

						if( Blend[ 2 ] < 128 )
						{
							fRGB[ 2 ] = _POW( Src[ 2 ] / 255.0f, ( 1.0f - Blend[ 2 ] / 255.0f ) * 2.0f ) ;
						}
						else
						{
							fRGB[ 2 ] = _POW( Src[ 2 ] / 255.0f, 0.5f / ( Blend[ 2 ] / 255.0f ) ) ;
						}

						fRGB[ 0 ] *= 255.0f ;
						fRGB[ 1 ] *= 255.0f ;
						fRGB[ 2 ] *= 255.0f ;
						_FTOL4( fRGB, iRGB ) ;

						B = iRGB[ 0 ] < 0 ? 0 : ( iRGB[ 0 ] > 255 ? 255 : iRGB[ 0 ] ) ;
						G = iRGB[ 1 ] < 0 ? 0 : ( iRGB[ 1 ] > 255 ? 255 : iRGB[ 1 ] ) ;
						R = iRGB[ 2 ] < 0 ? 0 : ( iRGB[ 2 ] > 255 ? 255 : iRGB[ 2 ] ) ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_HARDLIGHT :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						if( Blend[ 0 ] < 128 )
						{
							B = ( Src[ 0 ] * Blend[ 0 ] * 2 ) >> 8 ;
						}
						else
						{
							B = ( ( 2 * ( ( ( Src[ 0 ] + Blend[ 0 ] ) << 8 ) - ( Src[ 0 ] * Blend[ 0 ] ) ) ) >> 8 ) - 255 ;
						}
						if( B > 255 ) B = 255 ;

						if( Blend[ 1 ] < 128 )
						{
							G = ( Src[ 1 ] * Blend[ 1 ] * 2 ) >> 8 ;
						}
						else
						{
							G = ( ( 2 * ( ( ( Src[ 1 ] + Blend[ 1 ] ) << 8 ) - ( Src[ 1 ] * Blend[ 1 ] ) ) ) >> 8 ) - 255 ;
						}
						if( G > 255 ) G = 255 ;

						if( Blend[ 2 ] < 128 )
						{
							R = ( Src[ 2 ] * Blend[ 2 ] * 2 ) >> 8 ;
						}
						else
						{
							R = ( ( 2 * ( ( ( Src[ 2 ] + Blend[ 2 ] ) << 8 ) - ( Src[ 2 ] * Blend[ 2 ] ) ) ) >> 8 ) - 255 ;
						}
						if( R > 255 ) R = 255 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_EXCLUSION :
			{
				do
				{
					i = Width ;
					do
					{
						TempBlendRatio = BlendRatio * Blend[ 3 ] ;

						B = ( ( ( Src[ 0 ] + Blend[ 0 ] ) << 8 ) - 2 * ( Src[ 0 ] * Blend[ 0 ] ) ) >> 8 ;
						if( B > 255 ) B = 255 ;

						G = ( ( ( Src[ 1 ] + Blend[ 1 ] ) << 8 ) - 2 * ( Src[ 1 ] * Blend[ 1 ] ) ) >> 8 ;
						if( G > 255 ) G = 255 ;

						R = ( ( ( Src[ 2 ] + Blend[ 2 ] ) << 8 ) - 2 * ( Src[ 2 ] * Blend[ 2 ] ) ) >> 8 ;
						if( R > 255 ) R = 255 ;

						Dest[ 0 ] = ( BYTE )( ( ( Src[ 0 ] << 16 ) + ( B - Src[ 0 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 1 ] = ( BYTE )( ( ( Src[ 1 ] << 16 ) + ( G - Src[ 1 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 2 ] = ( BYTE )( ( ( Src[ 2 ] << 16 ) + ( R - Src[ 2 ] ) * TempBlendRatio ) >> 16 ) ;
						Dest[ 3 ] = Src[ 3 ] ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_NORMAL_ALPHACH :
			{
				DWORD TempAlpha ;
				DWORD ReverseBlendAlpha ;
				DWORD BlendAlpha ;

				do
				{
					i = Width ;
					do
					{
						BlendAlpha = ( Blend[ 3 ] * BlendRatio ) >> 8 ;

						ReverseBlendAlpha = 256 - BlendAlpha ;
						TempAlpha = ReverseBlendAlpha * Src[ 3 ] + ( BlendAlpha << 8 ) ;
						if( TempAlpha != 0 )
						{
							Dest[ 0 ] = ( BYTE )( ( ReverseBlendAlpha * Src[ 3 ] * Src[ 0 ] + ( ( BlendAlpha * Blend[ 0 ] ) << 8 ) ) / TempAlpha ) ;
							Dest[ 1 ] = ( BYTE )( ( ReverseBlendAlpha * Src[ 3 ] * Src[ 1 ] + ( ( BlendAlpha * Blend[ 1 ] ) << 8 ) ) / TempAlpha ) ;
							Dest[ 2 ] = ( BYTE )( ( ReverseBlendAlpha * Src[ 3 ] * Src[ 2 ] + ( ( BlendAlpha * Blend[ 2 ] ) << 8 ) ) / TempAlpha ) ;
							Dest[ 3 ] = ( BYTE )( TempAlpha >> 8 ) ;
						}

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_ADD_ALPHACH :
			{
				DWORD TempAlpha ;
				DWORD TempC ;
				DWORD BlendAlpha ;

				do
				{
					i = Width ;
					do
					{
						BlendAlpha = ( Blend[ 3 ] * BlendRatio ) >> 8 ;
						TempAlpha = ( ( 256 - BlendAlpha ) * Src[ 3 ] + ( BlendAlpha << 8 ) ) >> 8 ;
						if( TempAlpha != 0 )
						{
							TempC = ( Src[ 3 ] * Src[ 0 ] + BlendAlpha * Blend[ 0 ] ) / TempAlpha ;
							Dest[ 0 ] = TempC > 255 ? 255 : ( BYTE )TempC ;

							TempC = ( Src[ 3 ] * Src[ 1 ] + BlendAlpha * Blend[ 1 ] ) / TempAlpha ;
							Dest[ 1 ] = TempC > 255 ? 255 : ( BYTE )TempC ;

							TempC = ( Src[ 3 ] * Src[ 2 ] + BlendAlpha * Blend[ 2 ] ) / TempAlpha ;
							Dest[ 2 ] = TempC > 255 ? 255 : ( BYTE )TempC ;

							Dest[ 3 ] = ( BYTE )( TempAlpha ) ;
						}

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_MULTIPLE_A_ONLY :
			{
				TempBlendRatio = BlendRatio * 255 ;
				do
				{
					i = Width ;
					do
					{
						A = ( Src[ 3 ] * Blend[ 3 ] ) >> 8 ;
						Dest[ 0 ] = Src[ 0 ] ;
						Dest[ 1 ] = Src[ 1 ] ;
						Dest[ 2 ] = Src[ 2 ] ;
						Dest[ 3 ] = ( BYTE )( ( ( Src[ 3 ] << 16 ) + ( A - Src[ 3 ] ) * TempBlendRatio ) >> 16 ) ;

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;

		case DX_GRAPH_BLEND_PMA_MULTIPLE_A_ONLY :
			{
				int LIN_R, LIN_G, LIN_B ;

				TempBlendRatio = BlendRatio * 255 ;
				do
				{
					i = Width ;
					do
					{
						A = ( Src[ 3 ] * Blend[ 3 ] ) >> 8 ;
						Dest[ 3 ] = ( BYTE )( ( ( Src[ 3 ] << 16 ) + ( A - Src[ 3 ] ) * TempBlendRatio ) >> 16 ) ;

						if( Src[ 3 ] == 0 )
						{
							Dest[ 0 ] = 0 ;
							Dest[ 1 ] = 0 ;
							Dest[ 2 ] = 0 ;
						}
						else
						{
							LIN_B = ( int )( ( Src[ 0 ] << 8 ) / Src[ 3 ] ) ; if( LIN_B > 255 ) LIN_B = 255 ;
							LIN_G = ( int )( ( Src[ 1 ] << 8 ) / Src[ 3 ] ) ; if( LIN_G > 255 ) LIN_G = 255 ;
							LIN_R = ( int )( ( Src[ 2 ] << 8 ) / Src[ 3 ] ) ; if( LIN_R > 255 ) LIN_R = 255 ;

							Dest[ 0 ] = ( BYTE )( ( LIN_B * Dest[ 3 ] ) >> 8 ) ;
							Dest[ 1 ] = ( BYTE )( ( LIN_G * Dest[ 3 ] ) >> 8 ) ;
							Dest[ 2 ] = ( BYTE )( ( LIN_R * Dest[ 3 ] ) >> 8 ) ;
						}

						Src   += 4 ;
						Blend += 4 ;
						Dest  += 4 ;
					}while( -- i ) ;

					Src   += SrcAddPitch ;
					Blend += SrcAddPitch ;
					Dest  += DestAddPitch ;
				}while( -- Height ) ;
			}
			break ;
		}

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

extern int	GraphBlend_RGBA_Select_Mix( GRAPHFILTER_INFO *Info, int SelectR, int SelectG, int SelectB, int SelectA )
{
	// VF[_[g邩ǂŏ𕪊
	if( GSYS.HardInfo.UseShader == TRUE )
	{
		GraphBlend_RGBA_Select_Mix_PF( Info, SelectR, SelectG, SelectB, SelectA ) ;
	}
	else
	{
		// VF[_[gȂꍇ

		BYTE *Src ;
		BYTE *Blend ;
		BYTE *Dest ;
		DWORD i ;
		DWORD Width ;
		DWORD Height ;
		DWORD SrcAddPitch ;
		DWORD BlendAddPitch ;
		DWORD DestAddPitch ;

		if( GraphFilter_SoftImageSetup( Info ) < 0 )
			return -1 ;

		Src = ( BYTE * )Info->SrcImage.GraphData ;
		Blend = ( BYTE * )Info->BlendImage.GraphData ;
		Dest = ( BYTE * )Info->DestImage.GraphData ;

		Width  = Info->SrcX2 - Info->SrcX1 ;
		Height = Info->SrcY2 - Info->SrcY1 ;

		SrcAddPitch   = Info->SrcImage.Pitch   - Width * 4 ;
		BlendAddPitch = Info->BlendImage.Pitch - Width * 4 ;
		DestAddPitch  = Info->DestImage.Pitch  - Width * 4 ;

		do
		{
			i = Width ;
			do
			{
				switch( SelectB )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 0 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 0 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 0 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 0 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 0 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 0 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 0 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 0 ] = Blend[ 3 ] ; break ;
				}

				switch( SelectG )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 1 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 1 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 1 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 1 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 1 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 1 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 1 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 1 ] = Blend[ 3 ] ; break ;
				}

				switch( SelectR )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 2 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 2 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 2 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 2 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 2 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 2 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 2 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 2 ] = Blend[ 3 ] ; break ;
				}

				switch( SelectA )
				{
				case DX_RGBA_SELECT_SRC_R :   Dest[ 3 ] = Src[ 2 ] ;   break ;
				case DX_RGBA_SELECT_SRC_G :   Dest[ 3 ] = Src[ 1 ] ;   break ;
				case DX_RGBA_SELECT_SRC_B :   Dest[ 3 ] = Src[ 0 ] ;   break ;
				case DX_RGBA_SELECT_SRC_A :   Dest[ 3 ] = Src[ 3 ] ;   break ;
				case DX_RGBA_SELECT_BLEND_R : Dest[ 3 ] = Blend[ 2 ] ; break ;
				case DX_RGBA_SELECT_BLEND_G : Dest[ 3 ] = Blend[ 1 ] ; break ;
				case DX_RGBA_SELECT_BLEND_B : Dest[ 3 ] = Blend[ 0 ] ; break ;
				case DX_RGBA_SELECT_BLEND_A : Dest[ 3 ] = Blend[ 3 ] ; break ;
				}

				Src   += 4 ;
				Blend += 4 ;
				Dest  += 4 ;
			}while( -- i ) ;

			Src   += SrcAddPitch ;
			Blend += SrcAddPitch ;
			Dest  += DestAddPitch ;
		}while( -- Height ) ;

		GraphFilter_SoftImageTerminate( Info ) ;
	}

	// I
	return 0 ;
}

#ifdef DX_USE_NAMESPACE

}

#endif // DX_USE_NAMESPACE

#endif // DX_NON_FILTER


